/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *  MA 02110-1301, USA.
 *
 *  Copyright © 2006 Pierre Habouzit
 */
/*
 * This file is part of mutt-ng, see http://www.muttng.org/.
 * It's licensed under the GNU General Public License,
 * please see the file GPL in the top level source directory.
 */

#ifndef MUTT_LIB_LIB_URL_H
#define MUTT_LIB_LIB_URL_H

typedef enum url_scheme {
    U_FILE,
    U_POP,
    U_POPS,
    U_IMAP,
    U_IMAPS,
    U_NNTP,
    U_NNTPS,
    U_MAILTO,
    U_UNKNOWN
} url_scheme_t;

#define U_DECODE_PASSWD (1)

typedef struct ciss_url {
    url_scheme_t scheme;
    char *user;
    char *pass;
    char *host;
    int   port;
    char *path;
} ciss_url_t;

char *url_decode(char *);

url_scheme_t url_check_scheme (const char *s);
int url_parse_ciss(ciss_url_t *ciss, char *src);
int url_ciss_tostring(const ciss_url_t *ciss, char *dst, ssize_t len, int flags);

#endif /* MUTT_LIB_LIB_URL_H */
